<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset='utf-8'>
        <title>Lucky Dice Casino Task 23B.60 Task 44.50</title>
        <meta name='viewport' content='width=device-width, initial-scale=1'>
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        <style>
            .img-cover{
                background-image: url(Img/cover.jpg);
                background-repeat: repeat-x;
            }
            body{
                background-color: rgb(230, 60, 60);
            }

        </style>
    </head>
<body>
    <div class="container-fluid">
        <div class="row">
            <img class="img-cover" style="width:100%;height: 120px;">
        </div>
    </div>
    <div class="container">
        <div class="row ">
            <div class="col-5 text-center container">
                <div class="row form-group">
                    <div class="col-12">
                        <h4><b>Nhập thông tin của bạn</b></h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-3">
                        <label style="color: #FFF000;">Username</label>
                    </div>
                    <div class="col-9">
                        <input id="inp-username" class="form-control" type="text" placeholder="Nhập Username...">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-3">
                        <label style="color: #FFF000;">Firstname</label>
                    </div>
                    <div class="col-9">
                        <input id="inp-firstname" class="form-control" type="text" placeholder="Nhập Firstname...">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-3">
                        <label style="color: #FFF000;">Lastname</label>
                    </div>
                    <div class="col-9">
                        <input id="inp-lastname" class="form-control" type="text" placeholder="Nhập Lastname...">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <button onclick="onBtnNemClick()" class="btn btn-success button-width w-75" type="button">Ném</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-dice" class="img-thumbnail" src="Img/diceRound.gif" alt="Hình xúc xắc" >
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p style="color: #FFF000;" id="p-mess">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3 text-center">
                <div class="row form-group">
                    <div class="col-12 ">
                        <p style="color: #FFF000;">Voucher</p>
                        <p style="color: #FFF000;" id="p-voucher-id">No ID</p>
                        <p style="color: #FFF000;" id="p-voucher-percent">0%</p>
                    </div>
                    <div class="row form-group">
                        <div class="col-12">
                            <img id="img-prize" class="img-thumbnail" src="Img/no-present.jpg">
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12 text-center">
                <button onclick="onBtnDiceHistoryClick()" class="btn btn-primary button-width w-25">Dice History</button>
                <button onclick="onBtnVoucherHistoryClick()" class="btn btn-primary button-width w-25">Voucher History</button>
                <button onclick="onBtnPresentHistoryClick()" class="btn btn-primary button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row" >
            <div class="col-12" style="display: none;background-color: aliceblue;" id="div-dices">
                <div class="mt-5" >
                    <table id="history-placeholder-table" class="table table-striped table-bordered table-hover">
                      <thead>
                        <tr>
                          <th>Lượt</th>
                          <th>Dice</th>
                        </tr>
                      </thead>
                      <tbody>
                        
                      </tbody>
                    </table>
                  </div>
            </div>
            <div class="col-12" id="div-voucher"style="display: none;background-color: aliceblue;">
                <div class="mt-5"  >
                    <table id="t-voucher-history" class="table table-striped table-bordered table-hover">
                      <thead>
                        <tr>
                          <th>Mã Giảm Giá</th>
                          <th>Phần trăm Giảm Giá</th>
                        </tr>
                      </thead>
                      <tbody>
                        
                      </tbody>
                    </table>
                </div>
            </div>
            <div class="col-12" id="div-prize" style="display: none;background-color: aliceblue;">
                <div class="mt-5">
                    <table id="t-prize-history" class="table table-striped table-bordered table-hover">
                      <thead>
                        <tr>
                          <th># Game</th>
                          <th>Present</th>
                        </tr>
                      </thead>
                      <tbody id="tbody-dice-history-prize">
                   
                      </tbody>
                    </table>
                </div>
            </div>
         
        </div>
    </div>


    <script>
        gDataObject={
            username : "",
            firstname : "",
            lastname : "",
        }

        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        const gEND_OF_ROW_COL = -1;
        const gCOL_LUOT = 0;
        const gCOL_DICE = 1;
        const gCOL_MA_GIAM_GIA = 0;
        const gCOL_PHAN_TRAM = 1;

        //Hàm xử lý nút ném
        function onBtnNemClick(){
            "use strict";
            //B1 Thu thập dữ liệu
            thuThapDuLieu(gDataObject);
            //B2 validate dữ liệu
            var vCheck = valiDateData(gDataObject)
       
            if(vCheck == true){
                //B3 gọi api sever
                var vXmlHttpDice = new XMLHttpRequest();
                callAPIDice(vXmlHttpDice,gDataObject);
                vXmlHttpDice.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                        //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                        console.log(vXmlHttpDice.responseText);
                        // parsing to object
                        var vResponse = JSON.parse(vXmlHttpDice.responseText);
                        console.log(vResponse);
                        // get result dice
                        var vDiceReady = vResponse.dice;
                        console.log("Kết quả : " + vDiceReady);
                        //Gọi hàm hiển thị dice
                        changeDice(vDiceReady);
                        //gọi hàm hiển thị lời nhắn
                        changeMess(vDiceReady);
                        //hiển thị voucher và %
                        changeVoucherId(vResponse);
                        //hiển thị ảnh phần thưởng
                        changeGift(vResponse);
                    }

                }

            }
            //B4 Hiển thị dữ liệu  
        }

        //Hàm thu thập dữ liệu
        function thuThapDuLieu(paramData){
            "use strict";
            var vInpUsername = document.getElementById("inp-username");
            var vInpFirstname = document.getElementById("inp-firstname");
            var vInpLastname = document.getElementById("inp-lastname");

            paramData.username = vInpUsername.value.trim();
            paramData.firstname = vInpFirstname.value.trim();
            paramData.lastname = vInpLastname.value.trim();
        }

        //Hàm validate dữ liệu
        function valiDateData(paramData){
            "use strict";
            if(paramData.username == ""){
                alert("Username không được để trống!!!")
                return false;
            }
            if(paramData.firstname == ""){
                alert("Firstname không được để trống!!!")
                return false;
            }
            if(paramData.lastname == ""){
                alert("Lastname không được để trống!!!")
                return false;
            }
            return true;
        }

        //Hàm call API
        function callAPIDice(paramXmlHttp,paramObject){
            "use strict"
            paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
            paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
            paramXmlHttp.send(JSON.stringify(paramObject));
        }

        //Hàm đổi hình khi có kêt quả xúc xắc
        function changeDice(paramDice){
            "use strict";
            var vImgDice = document.getElementById("img-dice");
            switch(paramDice){
                case 1 :
                    vImgDice.src = "Img/1.png";
                    break;
                case 2 :
                    vImgDice.src = "Img/2.png";
                    break;
                case 3 :
                    vImgDice.src = "Img/3.png";
                    break;
                case 4 :
                    vImgDice.src = "Img/4.png";
                    break; 
                case 5 :
                    vImgDice.src = "Img/5.png";
                    break;   
                default :
                    vImgDice.src = "Img/6.png";
                    break;                 
            }
        }

        //Hàm hiển thị lời nhắn chúc mừng
        function changeMess(paramDice){
            "use strict";
            var vMess = document.getElementById("p-mess");
            if(paramDice < 4){
                vMess.innerHTML = ("Xui thôi đừng nản bạn nhé !!! :)");
            }else{
                vMess.innerHTML = ("Winner Winner Chicken Dinner !!!")
            }
        }

        //Hàm hiển thị voucher
        function changeVoucherId(paramVoucher){
            "use strict";
            var vVoucherId = document.getElementById("p-voucher-id");
            var vVoucherPercent = document.getElementById("p-voucher-percent");

            if(paramVoucher.voucher != null){
                vVoucherId.innerHTML = "Voucher Id : " + paramVoucher.voucher.maVoucher;
                vVoucherPercent.innerHTML ="Phần trăm giảm giá : " + paramVoucher.voucher.phanTramGiamGia + "%"
            }else{
                vVoucherId.innerHTML = "";
                vVoucherPercent.innerHTML = "";
            }
        }

        //Hàm hiển thị hình nhận quà
        function changeGift(paramPrize){
            "use strict";
            var vImgGift = document.getElementById("img-prize");
            var vPrize = paramPrize.prize;
            if(vPrize === null){
                vImgGift.src = "Img/no-present.jpg"
            }
            if(vPrize === "Mũ"){
                vImgGift.src = "Img/hat.jpg"
            }
            if(vPrize === "Áo"){
                vImgGift.src = "Img/Ao-khoac.jpg"
            }
            if(vPrize === "Xe máy"){
                vImgGift.src = "Img/xe-mo-to.jpg"
            }
            if(vPrize === "Ô tô"){
                vImgGift.src = "Img/car-1.jpg"
            }
        }



        //Hàm xử lý nút dice history
        function onBtnDiceHistoryClick(){
            "use strict";
            console.log("%c Nút Dice history đã được nhấn!!!","color:crimson");
            //B1 lấy thông tin dữ liệu
            thuThapDuLieu(gDataObject);
            //B2 validate dữ liệu
            var vCheck = valiDateData(gDataObject);
            var vUsername = gDataObject.username;
            if(vCheck == true){
                //B3 Gọi Api sever
                var vXmlHttpDiceHistory = new XMLHttpRequest();
                callAPIHistoryDice(vXmlHttpDiceHistory,vUsername);
                vXmlHttpDiceHistory.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vVoucherHistory = vXmlHttpDiceHistory.responseText;
                        // console.log(vVoucherHistory);
                        var vVoucherHistoryObject = JSON.parse(vXmlHttpDiceHistory.responseText);
                        var vDice = vVoucherHistoryObject.dices;
                        console.log(vVoucherHistory);
                        //B4 Hiển thị dữ liệu
                        showHistoryTable(vDice);

                    }
                }
            } 
        }
        
    

        //Hàm gọi Api history sever
        function callAPIHistoryDice(paramXmlHttp,paramUser){
            "use strict";
            paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramUser, true);
            paramXmlHttp.send();
        }

        //Hàm show dữ liệu lên table
        function showHistoryTable(paramDice){
            "use strict";
            var vDivShowResult = document.getElementById("div-dices");
            vDivShowResult.style.display = "block";
            var vDivVoucher = document.getElementById("div-voucher");
            vDivVoucher.style.display = "none";
            var vDivPrize = document.getElementById("div-prize");
            vDivPrize.style.display = "none";
            //show dữ liệu lên table
            var vDiceHistoryTable = document.getElementById("history-placeholder-table");
            // truy xuất được phần tử tbody trong table
            var vTableBody = vDiceHistoryTable.getElementsByTagName("tbody")[0];
            // -- thêm các dòng vào bảng 
            vTableBody.innerHTML= "";
            for (var bI = 0 ; bI < paramDice.length ; bI++) {
                // thêm dòng cho table
                var bNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
                // thêm các ô cho dòng
                var bLuotCell = bNewRow.insertCell(gCOL_MA_GIAM_GIA);
                var bDiceCell = bNewRow.insertCell(gCOL_PHAN_TRAM);
                // điền dữ liệu cho từng ô
                bLuotCell.innerHTML = bI + 1;
                bDiceCell.innerHTML = paramDice[bI];
            }
        }
    

        //Hàm xử lý sự kiện show dice history click
        function onBtnVoucherHistoryClick(){
            "use strict";
            console.log("%c Nút voucher history đã được nhấn!!!","color:violet")
            //B1 Đọc dữ liệu
            thuThapDuLieu(gDataObject);
            //B2 validate dữ liệu
            var vCheck = valiDateData(gDataObject);
            var vUsername = gDataObject.username;
            if (vCheck == true){
                var vXmlHttpVoucherHistory = new XMLHttpRequest();
                callAPIGetDiceHistoryVoucher(vXmlHttpVoucherHistory,vUsername)
                //B3 gọi APi sever
                vXmlHttpVoucherHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        //B4 hiển thị dữ liệu
                        var vVoucherHistory = JSON.parse(vXmlHttpVoucherHistory.responseText);
                        var vVoucher = vVoucherHistory.vouchers;
                        console.log(vXmlHttpVoucherHistory.responseText);
                        if(vVoucher != null){
                            hienThiDuLieuVoucher(vVoucher);
                        }
                        
                    }
                }
            }
        }


        //hàm gọi api lấy lich sử xúc xắc
        function callAPIGetDiceHistoryVoucher(paramXmlHttp,paramUser){
                "use strict";
                paramXmlHttp.open("GET", gBASE_URL + "/voucher-history?username=" + paramUser, true);
                paramXmlHttp.send();
            }

        //hàm xử lý hiện thị
        function hienThiDuLieuVoucher(paramVoucher){
            "use strict";
            var vDivVoucher = document.getElementById("div-voucher");
            vDivVoucher.style.display = "block";
            var vDivVoucher = document.getElementById("div-dices");
            vDivVoucher.style.display = "none";
            var vDivPrize = document.getElementById("div-prize");
            vDivPrize.style.display = "none";
            //show dữ liệu lên table
            var vDiceVoucherTable = document.getElementById("t-voucher-history");
            // truy xuất được phần tử tbody trong table
            var vTableBodyVoucher = vDiceVoucherTable.getElementsByTagName("tbody")[0];
             // -- thêm các dòng vào bảng 
            vTableBodyVoucher.innerHTML= "";
            for (var bI = 0 ; bI < paramVoucher.length ; bI++) {
                // thêm dòng cho table
                var bNewRow = vTableBodyVoucher.insertRow(gEND_OF_ROW_COL);
                // thêm các ô cho dòng
                var bMaGiamGiaCell = bNewRow.insertCell(gCOL_MA_GIAM_GIA);
                var bPhanTramCell = bNewRow.insertCell(gCOL_PHAN_TRAM);
                // điền dữ liệu cho từng ô
                bMaGiamGiaCell.innerHTML = paramVoucher[bI].maVoucher;
                bPhanTramCell.innerHTML = paramVoucher[bI].phanTramGiamGia + "%";
            }

        }
    
        //Hàm xử lý nút present history
        function onBtnPresentHistoryClick(){
            "use strict"
            console.log("%c Nút present history đã được nhấn !!!","color:blue")
            //B1 Đọc dữ liệu
            thuThapDuLieu(gDataObject);
            //B2 validate dữ liệu
            var vCheck = valiDateData(gDataObject);
            var vUsername = gDataObject.username;
            if (vCheck == true){
                var vXmlHttpVoucherHistory = new XMLHttpRequest();
                callAPIGetDiceHistoryPresent(vXmlHttpVoucherHistory,vUsername)
                //B3 gọi APi sever
                vXmlHttpVoucherHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        //B4 hiển thị dữ liệu
                        var vPrizeHistory = JSON.parse(vXmlHttpVoucherHistory.responseText);
                        var vPrize = vPrizeHistory.prizes;
                        console.log(vXmlHttpVoucherHistory.responseText);
                        hienThiDuLieuPrize(vPrize);
                    }
                }
            }
        }
        
        //hàm gọi api lấy lich sử prize
        function callAPIGetDiceHistoryPresent(paramXmlHttp,paramUser){
            "use strict";
            paramXmlHttp.open("GET", gBASE_URL + "/prize-history?username=" + paramUser, true);
            paramXmlHttp.send();
        }

        //hàm xử lý hiện thị prize
        function hienThiDuLieuPrize(paramPrize){
            "use strict";
            var vDivVoucher = document.getElementById("div-dices");
            vDivVoucher.style.display = "none";
            var vDivVoucher = document.getElementById("div-voucher");
            vDivVoucher.style.display = "none";
            var vDivPrize = document.getElementById("div-prize");
            vDivPrize.style.display = "block";
            // hiển thị dữ liệu lịch sử vào bảng
            var vPrizeHistoryTable = document.getElementById("t-prize-history");
            // truy xuất được phần tử tbody trong table
            var vTableBodyPrize = vPrizeHistoryTable.getElementsByTagName("tbody")[0];
            //xóa dữ liệu bảng trắng
            vTableBodyPrize.innerHTML= "";
            for (var bI = 0 ; bI < paramPrize.length ; bI++) {
                // thêm dòng cho table
                var bNewRow = vTableBodyPrize.insertRow(gEND_OF_ROW_COL);
                // thêm các ô cho dòng
                var bGameCell = bNewRow.insertCell(0);
                var bPrizeCell = bNewRow.insertCell(1);
                // điền dữ liệu cho từng ô
                bGameCell.innerHTML = bI + 1;
                bPrizeCell.innerHTML = paramPrize[bI];
            }
        }
    
    
    
    
    </script>
</body>
</html>